package 3dgrid;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(mjd doy soy sod);

##
## $Id: 3dgrid.pm 9 2013-06-30 03:03:30Z vlbi $
##
##

BEGIN{

}
sub new($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_colmn($$$$){ ## a,b,c = 1,2,3,...
    my ($this, $a, $b, $c) = @_;
    $xcol = $a-1;
    $ycol = $b-1;
    $zcol = $c-1;
}

sub Read_file($$){
    my ($this, $file) = @_;
    
    open(IN, $file) || {
	print STDERR "Error: Cannot open file $file\n";
	return(-1);
    }
    (@xarr, @yarr, @zarr);
    my $max_col = $a > $b ? $a : $b;
    $max_col = $max_col < $c ? $c : $max_col;
    
    my $cnt=0;
    my $xcnt=0;
    my $ycnt=0;
    my $ini_flag=0;
    while(<IN>){
	if(/^\#/){
	    if($ini_flag ){
		if($ycnt>0){
		    $xcnt++;
		    $ycnt=0;
		}
		$ini_flag=0;
	    }
	    next;
	}
	my @terms = split(/\s+/);
	if( @terms < $max_col +1){
	    if($ini_flag){
		if($ycnt >0){
		    $ycnt=0; 
		    $xcnt++;
		}
		$init_flag=0;
	    }
	} 
	$xarr[$xcnt] = $terms[$xcol] if($ini_flag==0);
	$yarr[$ycnt] = $terms[$ycol];
	$zarr[$xcnt][$ycnt] = $terms[$zcol];
	$ycnt++;
	$ini_flag=1;
	$cnt++;
    }
    close(IN);

    if($cnt==0){
	printf STDERR "Error: data file ($file) does not contain xcol (%d) ycol (%d), xcol (%d)\n",
	$xcol, $ycol, $zcol;
	return(-1);
    }
    if($cnt != @xarr * @yarr){
	printf STDERR "Error: Total data number : %d != nxdata(%d) x nydata(%d)\n",
	$cnt, @xarr, @yarr;
	return(-1);
    }
    
    $this->{xarr} = \@xarr;
    $this->{yarr} = \@yarr;
    $this->{zarr} = \@zarr;
    $cnt;
}

sub Nx(){
    @xarr;
}

sub Ny(){
    @yarr;
}

sub Zarr(){
    @xarr;
}

use PGPLOT;
use Maxmin;

sub Plot_cntr($$){

    my ($xmax, $xmin) =  &maxmin(@xarr);
    my ($ymax, $ymin) =  &maxmin(@yarr);
    
    pgopen("/xw");
    pgsvp(0.2,0.8,0.2,0.8);
    

    pgswin();
    
    pgclos();
}
