#
#  Communication Server module for General 
#  @Auther: by M.Sekido 
#  @Date:  2007.5.18 
#  @Version: $Id: Com_srv.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Com_srv;
use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_srv_port($$){
    my ($pkg,$port) = @_;
    $pkg->{port}=$port;
}

sub Open_srvSocket($){
    my $pkg = shift;
    my $listening_socket = IO::Socket::INET->new(LocalPort => $pkg->{port},
						 Listen    => SOMAXCONN,
						 Proto     => 'tcp',
						 Reuse     => 1 );
    unless(defined($listening_socket)){
	print STDERR "Error in creating socket\n";
	printf STDERR " port: %d may be already in use\n", $pkg->{port};
	exit(1); 
    }
    $pkg->{srv_sock} = $listening_socket;
}

sub Wait_Connection($){
    my $pkg = shift;
    
#    while (1){

    printf STDERR " Waiting connection at port %d \n",
    $pkg->{port};
    
    my $new_socket = $pkg->{srv_sock}->accept();
    
    my $client_sockaddr = $new_socket->peername();
    unless(defined($client_sockaddr)){
	print STDERR "Error Socket address was not obtained.\n";
	return undef;
    }
    my ($client_port,$client_iaddr) = unpack_sockaddr_in($client_sockaddr);
    my $client_hostname = gethostbyaddr($client_iaddr, AF_INET);
    my $client_ip = inet_ntoa($client_iaddr);

    print STDERR 
	"Connected: $client_hostname($client_ip) Port: $client_port\n";
    select($new_socket); $|=1; # stop buffering 
    select(STDOUT);
    
    return $new_socket;
}

1;
