## Making hash database from reading the config file
##  by M.S.  2008/3/3
##  --- conf file is expected to be a list of 
##    <entry>  <value>  
###
#  @Version: $Id: Conf_hash.pm 9 2013-06-30 03:03:30Z vlbi $

package Conf_hash;
use Exporter;
use Carp;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Value($$){
    my ($pkg,$key) = @_;
    $pkg->{$key};
}

sub KeyList($){
    my $pkg = shift;
    unless( defined(%{$pkg})){
	print "E Conf_hash::KeyList() failed cause of undefined hash\n";
	return undef;
    }
    keys(%{$pkg});
}

sub Read($$){
    my ($pkg,$fname) = @_;
    unless(open(IN,$fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my $nent=0;
    while(<IN>){
	next if(/^\#/);
	if(/(\S+)\s+(\S+)/){
	    $pkg->{$1}=$2;
	    $nent++;
	}
    }
    return $nent;
}

sub Print($){
    my $pkg = shift;
    my $cnt=0;
    print "#---Config Parameters ---\n";
    foreach my $h (keys(%$pkg)){
	printf "%2d: %-12s  %s\n", $cnt,$h, $pkg->{$h};
	$cnt++;
    }
    print "#---------------------------\n";
}

1;
