#
#  Cor_mgr Server 
#  @Auther: by M.Sekido 
#  @Date:  2007.5.18 
#  @Version: $Id: Cor_mgr_srv.pm 12 2013-07-01 08:39:40Z vlbi $
#
#
package Cor_mgr_srv;
use Exporter;
#  use lib "$ENV{HOME}/prog/perl/module";
use Com_srv; 

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {'port' => 9001, 'dbg'=>0};
    bless $this;
    $this;
}

sub Set_Cor_clt($$){
    my $pkg = shift;
    $pkg->{cor_clt} = shift;
}

sub Set_srv_port($$){
    my ($pkg,$port) = @_;
    $pkg->{port}=$port;
}

sub Port($){
    my $pkg = shift;
    return $pkg->{port};
}

sub Set_dbg($){
    my $pkg = shift;
    $pkg->{dbg} = 1;
}

sub Open_srvSocket($){
    my $pkg = shift;
    my $srv = $pkg->{srv} = new Com_srv; 
    $srv->Set_srv_port($pkg->{port});
    my $listening_socket = $pkg->{lstn_sock} = $srv->Open_srvSocket();
}

sub Set_BaseIDs($\@){
    my $pkg = shift;
    $pkg->{baseids} = shift;
}

sub Wait_Connection($\@){
    my $pkg = shift;
    my $bentry = shift; ## Jog list in the que
    my $new_socket =  $pkg->{srv}->Wait_Connection();
#    if(!defined($new_socket) || $new_scoket == -1){
    if(!defined($new_socket)){
	print STDERR "Cor_mgr_srv::Wait_Connection(): Failed Com_srv::Wait_Conn.\n";
	return undef;
    }
    select($new_socket); $|=1; # stop buffering 
    select(STDOUT);
    my $entry;

    while (<$new_socket>){
	print "Received Message: $_ \n";
	## Expecting message like "2007/138-00:00:00 T a"
	if(m!Scan:\s*(\d{4}/\d{3}-\d\d:\d\d:\d\d)\s+(\S+\s+\S+.*)!){
	    my $time_str = $1;
	    my $tmpstr = $2;
	    my @terms = split(/\s+/,$tmpstr);
	    my $stid = $terms[0];
	    my $gid = $terms[1];
	    my $iscan = defined($terms[2])? $terms[2]:999 ;
	    my $dur = defined($terms[3])? $terms[3]:1000 ;
	    $entry= "$time_str:$stid:$gid:$iscan:$dur";
#	    $obs_entry->{$entry} = 1;
	    last;
	}elsif(m!Baseline\?!){
	    my $tmp = join(':', @{$pkg->{baseids}});
	    print $new_socket "Baseline=$tmp\n";
	    print STDERR "Baseline=$tmp\n" if($pkg->{dbg});
	    last;
	}elsif(m!Proc:Que\?!){
	    my $nent = @$bentry;
	    for(my $i=0; $i<$nent; $i++){
		print $new_socket "$$bentry[$i]\n";
		print STDERR "$$bentry[$i]\n" if($pkg->{dbg});
	    }
	    last;
	}elsif(m!Finish:(\S+):(\d{4}/\d{3}-\d\d:\d\d:\d\d\s+\S+\s+\S+)!){
	    my $corstat = $1 eq "OK" ? 1 : 0; 
	    my $ent = "$1:$2";
	    my $flist = $pkg->{fns_list}; ## Finished list;
	    my @fns_list;
	    if(defined(@$flist)){ @fns_list = @{$flist};   }
	    push(@fns_list, ($ent));
	    $pkg->{fns_list} = \@fns_list;
	    last;
	}elsif(m!Proc:Finish:(\S+)\?!){
	    my $bid = $1;
	    my $fnslist = $pkg->{fns_list};
	    unless(defined($fnslist)){
		print $new_socket "None\n";
		print STDERR "None\n"  if($pkg->{dbg});
		last;
	    }elsif($bid eq "ALL"){
		my $n = @$fnslist;
		for(my $i=0; $i<$n; $i++){
		    printf $new_socket "%s\n", $$fnslist[$i];
		    printf STDERR "%s\n", $$fnslist[$i] if($pkg->{dbg});
		}
	    }elsif($bid eq "COLLECT"){ ## Collect Info from all cor_servers
		my $n = @$fnslist;
		for(my $i=0; $i<$n; $i++){
		    printf $new_socket "%s\n", $$fnslist[$i];
		    printf STDERR "%s\n", $$fnslist[$i] if($pkg->{dbg});
		}
	    }else{
		my @lst = grep(/$bid/,@fnslist);
		my $n = @lst;
		for(my $i=0; $i<$n; $i++){ 
		    printf $new_socket "%s\n", $lst[$i];
		    printf STDERR "%s\n", $lst[$i]  if($pkg->{dbg});
		}
	    }
	    last;
	}
    }
    $new_socket->close();

    if(defined($entry)){return $entry;}
    else{ return undef;}
}

1;
