#  @Version: $Id: Evn_file.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Evn_file;

#use Exporter;
#@ISA = qw(Exporter);

#@EXPORT = qw(Soy Sod Fsize Set_str);

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub ScanName($){
    my $pkg=shift;
    return $pkg->{scanname};
}
sub StnCode($){
    my $pkg = shift;
    return $pkg->{stncode};
}
sub ExpName($){
    my $pkg = shift;
    return $pkg->{expname};
}


sub Print_info($){
    my $pkg = shift;
    my $epoch = $pkg->Time(6);
    my $out = sprintf "Exp:%s StnID:%s ScanID:%s Time:%s ",
    $pkg->ExpName(),    $pkg->StnCode(),     $pkg->ScanName, $epoch;
    $out .= sprintf "Fsize: %d",$pkg->{fsize}  if(defined($pkg->{fsize})); 
    return $out;
}

## mode =0 return yy soy
## mode =1 return yy doy sod
## mode =2 retrun yy doy hh mm ss
## mode =3 retrun doyhhmmss
## mode =4 retrun yyyydoyhhmmss
## mode =5 return Time_lib;
sub Time($;$){
    my ($this, $mode) = @_;
    $mode = 0 unless ( defined($mode));
    my @ydhms = $this->{tm}->YDHms();

    if( $mode == 0){
	return ($ydhms[0], $this->{soy});
    }elsif($mode == 1){
	return ($ydhms[0], $ydhms[1], $this->{sod});
    }elsif($mode == 2){
	return @ydhms;
    }elsif($mode == 3){
	return sprintf "%03d%02d%02d%02d",
	$ydhms[1],$ydhms[2],$ydhms[3],$ydhms[4];
    }elsif($mode == 4){
	return sprintf "%04d%03d%02d%02d%02d",
	$ydhms[0],$ydhms[1],$ydhms[2],$ydhms[3],$ydhms[4];
    }elsif($mode == 5){
	return $this->{tm};
    }elsif($mode == 6){
	return sprintf "%04dy%03dd%02dh%02dm%02ds",
	$ydhms[0],$ydhms[1],$ydhms[2],$ydhms[3],$ydhms[4];
    }
    
}

sub Set_fname0($$){
  my ($this, $str) = @_;
  my $ptn1 = "[0-9,a-z,A-Z]+";
  my $ptn2 = "[-_]";
  my $ptn3 = "([\\d,A-Z,-,:]+)";
  my $ptn_ons = ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . 
      "(\\d+)" . ${ptn2}. "flen=(\\d+)";
  my $ptn_ons2 = ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . 
      ${ptn1} . ${ptn2} .  "(\\d+)" . ".mk5";
  my $ptn_ons3 = ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} .
      ${ptn1} . ${ptn2} .  "(\\d+)" . ".evn";
  my $ptn_ons4 = ${ptn1} . ${ptn2} . "\\w{2}_(\\d{3})-(\\d\\d)(\\d\\d)";
  my $ptn_ons5 = ${ptn1} . ${ptn2} . "\\w{2}_(\\d{3})-(\\d\\d)(\\d\\d)(\\d\\d)";
  my $ptn_mez = ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . "\\d+" . ${ptn2} .
      ${ptn1} . "_(\\S+)_flen=(\\d+)[.evn]*";
  my $ptn_mez2 = ${ptn1} . ${ptn2} . ${ptn1} . ${ptn2} . "\\d+" . ${ptn2} .
      ${ptn1} . "_(\\S+)[.evn]*";
#      ${ptn1} .  ${ptn3} . "_flen=(\\d+)";
#  print "ptn = $ptn \n";
  use Time_lib;  
  my $tm = new Time_lib;
  if($str =~/${ptn_ons}$/){ ## Onsala Pattern 
      my $tstr = $1;
      $this->{fsize} = $2;
      unless($tstr =~/(\d{4})(\d{3})(\d\d)(\d\d)(\d\d)/){
	  print STDERR "Error in Evn_file::Set_fname(): Failed to fit time fmt\n";
	  print STDERR "file=$str\n TimeStr=$tstr\n";
	  return -1;
      }
      my @ydhms = ($1, $2, $3, $4, $5);
      $tm->Set_time_ydhms(@ydhms);
  }elsif($str =~/${ptn_ons2}$/ || $str =~/${ptn_ons3}$/){ ## Onsala Pattern 
      my $tstr = $1;
      unless($tstr =~/(\d{4})(\d{3})(\d\d)(\d\d)(\d\d)/){
	  print STDERR "Error in Evn_file::Set_fname(): Failed to fit time fmt\n";
	  print STDERR "file=$str\n TimeStr=$tstr\n";
	  return -1;
      }
      my @ydhms = ($1, $2, $3, $4, $5);
      $tm->Set_time_ydhms(@ydhms);
  }elsif($str =~/${ptn_ons5}$/){ ## Onsala Pattern 
      my $doy=$1;
      my $hh=$2;
      my $mm=$3;
      my $ss=$4;
      my @t1 = localtime(time());
      my $year = $t1[5]+1900;
      my @ydhms = ($year,$doy,$hh,$mm,$ss);
      $tm->Set_time_ydhms(@ydhms);
  }elsif($str =~/${ptn_ons4}$/){ ## Onsala Pattern 
      my $doy=$1;
      my $hh=$2;
      my $mm=$3;
      my @t1 = localtime(time());
      my $year = $t1[5]+1900;
      my @ydhms = ($year,$doy,$hh,$mm,0);
      $tm->Set_time_ydhms(@ydhms);
  }elsif($str =~/${ptn_mez}$/){ ## Metzahobi Pattern 
      my $tstr = $1;
      $this->{fsize} = $2;
      if($tstr =~/(\d{4})-(\d\d)-(\d\d)\S(\d\d):(\d\d):(\d\d)/){
	  my @ymdhms = ($1, $2, $3, $4, $5, $6);
	  $tm->Set_time_ymd(@ymdhms);
      }elsif($tstr =~/(\d{4})(\d{3})(\d\d)(\d\d)(\d\d)/){
	  my @ydhms = ($1, $2, $3, $4, $5);
	  $tm->Set_time_ydhms(@ydhms);
      }else{
	  print STDERR "Error in Evn_file::Set_fname(): Failed to fit time fmt\n";
	  print STDERR "file=$str\n TimeStr=$tstr\n";
	  return -1;
      }
  }elsif($str =~/${ptn_mez2}$/){ ## Metzahobi Pattern2 
      my $tstr = $1;
      if($tstr =~/(\d{4})-(\d\d)-(\d\d)\S(\d\d):(\d\d):(\d\d)/){
	  my @ymdhms = ($1, $2, $3, $4, $5, $6);
	  $tm->Set_time_ymd(@ymdhms);
      }elsif($tstr =~/(\d{4})(\d{3})(\d\d)(\d\d)(\d\d)/){
	  my @ydhms = ($1, $2, $3, $4, $5);
	  $tm->Set_time_ydhms(@ydhms);
      }else{
	  print STDERR "Error in Evn_file::Set_fname(): Failed to fit time fmt\n";
	  print STDERR "file=$str\n TimeStr=$tstr\n";
	  return -1;
      }
  }else{
      print STDERR "Error filenem ($str) is not in the form as expected\n";
      return -1;
  }

#  my $sod = (($ydhms[2] * 60.)+$ydhms[3])*60. + $ydhms[4];
#  my $soy =  $ydhms[1] * 86400. + $sod;

  $this->{tm} = $tm;
#  $this->{ydhms} = \@ydhms;
  $this->{sod} = $tm->Sod();
  $this->{doy} = $tm->Doy();
  $this->{fsize} = $fsize;
  return 0;
}

sub Set_fname($$){
  my ($this, $str) = @_;
  
  use Time_lib;  
  my $tm = new Time_lib;
  my @t1 = localtime(time());
  my $year = $t1[5]+1900;
  my @terms = split(/[_,\.]/,$str);
  if(@terms < 5){
      print STDERR "Error filenem ($str) is not in the form as expected.";
      print STDERR " Filename must follow the rule of file naming convension: ";
      print STDERR " http://www.haystack.mit.edu/tech/vlbi/evlbi/evlbi_memos/filenaming_conventions.pdf and <data start time> must be in the file name.\n";
      return -1;
  }

  $this->{expname} = shift(@terms);
  $this->{stncode} = shift(@terms);
  $this->{scanname} = shift(@terms);
  if(@terms >0){
      my $sttime = shift(@terms);
      if($sttime =~m!(\d{4})(\d{3})[-/]*(\d\d)(\d\d)(\d\d)!){
	  $tm->Set_time_ydhms(($1,$2,$3,$4,$5));
      }elsif($sttime =~/(\d{3})[d-]*(\d\d)h*(\d\d)m*(\d\d)s*/){
	  $tm->Set_time_ydhms(($year,$1,$2,$3,$4));
      }elsif($sttime =~/(\d{3})[d-]*(\d\d)h*(\d\d)m*/){
	  $tm->Set_time_ydhms(($year,$1,$2,$3,0));
      }elsif($sttime =~m!(\d{4})[y/]*(\d{3})!){
	  $tm->Set_time_ydhms(($1,$2,0,0,0));
      }elsif($sttime =~/(\d{4})-*(\d\d)-*(\d\d)/){
	  my @ymd = ($1,$2,$3);
	  if($this->{scanname} =~/(\d{3})-(\d\d)(\d\d)/){
	      $tm->Set_time_ymd(($ymd[0],$ymd[1],$ymd[2],$2,$3,0));
	  }else{
	      $tm->Set_time_ymd(($ymd[0],$ymd[1],$ymd[2],0,0,0));
	  }
      }
  }
  if(@terms >0){
      my $auxinf = shift(@terms);   
      $this->{fsize} =$1 if($auxinf =~/flen=(\d+)/)
  }


#  my $sod = (($ydhms[2] * 60.)+$ydhms[3])*60. + $ydhms[4];
#  my $soy =  $ydhms[1] * 86400. + $sod;

  $this->{tm} = $tm;
#  $this->{ydhms} = \@ydhms;
  $this->{sod} = $tm->Sod();
  $this->{doy} = $tm->Doy();

  return 0;
}

sub Soy($){ my $this = shift;   return $this->{soy};}
sub Sod($){ my $this = shift;   return $this->{sod};}
sub Fsize($){ my $this = shift;   return $this->{fsize};}


1;
