#  @Version: $Id: Frq_db.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Frq_db;
use Exporter;
use Carp;

@ISA = qw(Exporter);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Set_rfrq($$$){
    my ($pkg, $ch,$frq) = @_;
    unless(defined($pkg->{rfrq})){
	my %rfrq;
	$pkg->{rfrq} = \%bw;
    }
    ${$pkg->{rfrq}}->{$ch} =$frq;
}

sub Set_bw($$$){
    my ($pkg, $ch,$bw) = @_;
    unless(defined($pkg->{bw})){
	my %bw;
	$pkg->{bw} = \%bw;
    }
    ${$pkg->{bw}}->{$ch} =$bw;
}

sub Set_ulsb($$$){
    my ($pkg, $ch,$ul) = @_;
    unless(defined($pkg->{ulsb})){
	my %ulsb;
	$pkg->{ulsb} = \%ul;
    }
    ${$pkg->{ulsb}}->{$ch} =$ul;
}

sub Set_Sampling($$){
    my ($pkg,$srate) = @_;
    $pkg->{srate} = $srate;
}

sub Rfrq($$){
    my ($pkg,$ch) = @_;
    return ${$pkg->{rfrq}}->{$ch};
}

sub BW($$){
    my ($pkg,$ch) = @_;
    return ${$pkg->{bw}}->{$ch};
}

sub ULSB($$){
    my ($pkg,$ch) = @_;
    return ${$pkg->{ulsb}}->{$ch};
}

sub Sampling($){
    my $pkg = shift;
    return $pkg->{srate};
}

sub Read_vex($$){
    my ($pkg,$in)= @_;
    my $p = caller;
    my $H;
    if(defined($in)){
	if($in !~/^main/){ $H = $p . "::" . $in;}
	else{ $H =  $in;}
    }else{
	print STDERR "Error in Frq_db::Read(): in undefined\n";
	return -1;
    }
    
    my $line =<$H>;
    my $flag=0;
    my $frq_mode;
    my @mode_arr;

    while(!eof($H)){    
	next if($line =~/^\*/);
	if($line =~/^def\s+(\S+);/){
	    $frq_mode = $1;
	    push(@mode_arr,($frq_mode));
#	    $frq_db{$frq_mode} = new Frq_db;
	    $flag=1;
	    next;
	}
	next if($flag==0);
	my %frq_db;
	my @frq_arr;
	my @bw_arr;
	my $ul_arr;
	my $nch=0;
	while(!eof($H) && $flag==1){
	    next if($line =~/^\*/);
	    if($line =~m!sample_rate\s*=\s*(\S+)\s+Ms/sec\;!){
		$frq_db{Srate} = $1;
#		$frq_db{frq_mode}->Set_Sampling($1);
	    }elsif($line =~/chan_def\s*=\s*:\s*/){
		my @terms = split(/[\s,:]+/,$'); #')
		unless($terms[5] =~/&CH(\d+)/){
		    printf STDERR "Error in Vex_skd::Read_frq(): frq format is unexpected\n";
		    print STDERR " line = $line\n";
		    next;
		}
		my $ch = $1;

		$frq_arr[$ch] = $terms[0];
		$ul_arr[$ch] = $terms[2];
		$bw_arr[$ch] = $terms[3];
		$nch++;
	    }
	}continue{
	    $line = <$H>  unless(eof($H));
	    if($line =~/enddef/){
		$flag=0;
		$frq_db{rf} = \@frq_arr;
		$frq_db{bw} = \@bw_arr;
		$frq_db{ul} = \@ul_arr;
		$frq_db{nch} = $nch;
		$nch=0;
		$pkg->{$frq_mode} = \%frq_db;
		$icnt++;
		last;
	    }
	} ## Loop for contents of the modes

    }continue{
	$line = <$H>  unless(eof($H));
	last if($line =~/^\$/);
    } ## Loop for each modes 

    $pkg->{mode_arr} = \@mode_arr;
    return $line;
    
}
    
sub Mode_list($){
    my $pkg = shift;
    return @{$pkg->{mode_arr}};
}

sub Nch($$){
    my ($pkg,$mode) = @_;
    $pkg->{$mode}->{nch};
}

sub Print_ch($$$;$){
    my ($pkg, $mode,$ich,$out) = @_;
    $out = STDOUT unless(defined($out));
    my $frqdb = $pkg->{$mode};
    unless(defined(%$frqdb)){
	print STDERR "Error in Frq_db::Print_ch(): mode:$mode is not defined.\n";
	return -1;
    }
    my $rfarr =  $frqdb->{rf};
    my $bwarr =  $frqdb->{bw};
    my $ularr =  $frqdb->{ul};
    
    unless(defined($$rfarr[$ich]) && defined($$bwarr[$ich]) 
	   && defined($$ularr[$ich]) ){
	printf STDERR 
	    "Error in Frq_db::Print_ch(): rfarr[], bwarr, ularr for ch=%d is not defined.\n", $ich-1;
	return -1;
    }
    printf $out "ch%2d: %.4f MHz BW=%.1fMHz %s \n",
    $ich, $$rfarr[$ich], $$bwarr[$ich], $$ularr[$ich];
    return 0;
}

1;
