## Read file and return arbitrary value by interpolation
##  by M.S.  2011/12/31
##    <Xdata>  <Ydata>  
###
# @Version: $Id: Intp.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Intp;
use Exporter;
use Carp;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

## Get value by linear interpolation 
sub Value($$){
    my ($pkg,$x) = @_;
#    $x *= 1.e-9;
    my $xarr = $pkg->{xarr};
    my $yarr = $pkg->{yarr};
    my $ncnt = @$xarr;
    my @iarr;
    if($x <= $$xarr[0]){
	$iarr[0] = 0;
	$iarr[1] = 1;
    }elsif($x > $$xarr[$ncnt-1]){
	$iarr[0] = $ncnt-2;
	$iarr[1] = $ncnt-1;
    }else{
	my $j =0;
	$j++ while($$xarr[$j] < $x);
	$iarr[0] = $j-1;
	$iarr[1] = $j;
    }
    my $dx = $$xarr[$iarr[1]] - $$xarr[$iarr[0]];
    my $dy = $$yarr[$iarr[1]] - $$yarr[$iarr[0]];
    my $a = $dy/$dx;
    my $ret = $a*($x - $$xarr[$iarr[0]] ) + $$yarr[$iarr[0]];
    $ret;
}


sub Read($$){
    my ($pkg,$fname) = @_;
    unless(open(IN,$fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my (@xarr, @yarr);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	if(/\s*(\S+)\s+(\S+)/){
	    $xarr[$cnt] = $1;
	    $yarr[$cnt++] = $2;
	    $nent++;
	}
    }
    $pkg->{xarr}=\@xarr;
    $pkg->{yarr}=\@yarr;
    return $nent;
}

sub xRange($){
    my $pkg = shift;
    my @xarr = @{$pkg->{xarr}};
    return ($xarr[0],$xarr[$#xarr]);
}

1;
