# @Version: $Id: K5M5_cnf.pm 9 2013-06-30 03:03:30Z vlbi $
#
package K5M5_cnf;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw();

BEGIN{
}

sub new($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub M5_Dir($){
    my $pkg = shift;
    $pkg->{M5_DIR};
}

sub K5_Dir($$){
    my ($pkg, $ch) = @_;
    if($ch == 1){
	return @{$pkg->{K5_DIR1}};
    }elsif($ch ==2){
	return @{$pkg->{K5_DIR2}};
    }elsif($ch ==3){
	return @{$pkg->{K5_DIR3}};
    }elsif($ch ==4){
	return @{$pkg->{K5_DIR4}};
    }else{
	print STDERR "Error in K5M5_cnf::K5_Dir(): channel must be in 1-4\n";
	exit(1);
    }
} 

sub Ngrp($){
    my $pkg = shift;
    $pkg->{ngrp};
}

sub Info_File($){
 my $pkg = shift;
 $pkg->{INF};
}

sub Check($){
    my $this =shift;
    my $ngrp = $this->{ngrp};
    my $err_cnt=0;
    unless(defined(@{$this->{K5_DIR1}})){
	$err_cnt++;
	print STDERR "Error: K5_DIR1 is mission in conf file\n";
    };
    if($ngrp > 1){
	unless(defined(@{$this->{K5_DIR2}})){
	    $err_cnt++;
	    print STDERR "Error: K5_DIR2 is mission in conf file\n";
	};
	if($ngrp > 2){
	    unless(defined(@{$this->{K5_DIR3}})){
		$err_cnt++;
		print STDERR "Error: K5_DIR3 is mission in conf file\n";
	    }
	    if($ngrp > 3){
		unless(defined(@{$this->{K5_DIR4}})){
		    $err_cnt++;
		    print STDERR "Error: K5_DIR4 is mission in conf file\n";
		}
	    }
	    
	}	
    }
    
    if($err_cnt>0){ return -1;}
    else{ return 0;}
}

sub Read($$){
    my ($this, $infile) =@_;

    open(IN, $infile) || die "Cannot open file $infile \n";

    my $stflag=0; 
    my (@d1, @d2, @d3, @d4);
    my ($inf, $m5dir);

    while(<IN>){
	next if(/^\#/);
	if(/K5_DIR_1/){
	    $stflag=1; next;
	}elsif(/K5_DIR_2/){
	    $stflag=2; next;
	}elsif(/K5_DIR_3/){
	    $stflag=3; next;
	}elsif(/K5_DIR_4/){
	    $stflag=4; next;
	}elsif(/INFO_FILE/){
	    $stflag=5; next;
	}elsif(/M5_DIR/){
	    $stflag=6; next;
	}elsif(/NGRP\s+(\d+)/){
	    $this->{ngrp}=$1; next;
	}elsif($stflag ==1){ #K5_DIR_1
	    next unless(/(\S+)/);
	    push(@d1,($1));
	}elsif($stflag ==2){ #K5_DIR_2
	    next unless(/(\S+)/);
	    push(@d2,($1));
	}elsif($stflag ==3){ #K5_DIR_3
	    next unless(/(\S+)/);
	    push(@d3,($1));
	}elsif($stflag ==4){ #K5_DIR_4
	    next unless(/(\S+)/);
	    push(@d4,($1));
	}elsif($stflag ==5){ #INFO_FILE
	    next unless(/(\S+)/);
	    $inf = $1;
	}elsif($stflag ==6){ #M5_DIR
	    next unless(/(\S+)/);
	    $m5dir = $1;
	}
    }
    close(IN);

    $this->{K5_DIR1} = \@d1;
    $this->{K5_DIR2} = \@d2;
    $this->{K5_DIR3} = \@d3;
    $this->{K5_DIR4} = \@d4;    
    $this->{M5_DIR} = $m5dir;
    $this->{INF} = $inf;
    unless(defined($inf)){
	print STDERR 
	    "Error in K5M5_cnf::Read(): INF_FILE entry was not found in $infile\n";
	exit(1);
    }
    unless(defined($m5dir)){
	print STDERR 
	    "Error in K5M5_cnf::Read(): M5_DIR entry was not found in $m5dir\n";
	exit(1);
    }

}


1;
