# @Version: $Id: K5_corfmt.pm 9 2013-06-30 03:03:30Z vlbi $
#
package K5_corfmt;

#use Exporter;
#@ISA = qw(Exporter);

# @EXPORT = qw();

BEGIN{
    
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

sub Pcal_f($$){
  my ($pkg,$ich) = @_;
  my $frq_tab = $pkg->{frq_tab};
  my $line = $$frq_tab[$ich-1];
  my @terms = split(/\s+/,$line);
  return $terms[1];
}

sub Prc_host($){
    my $pkg = shift;
    return $pkg->{prc_host};
}

sub Iobs($){
    my $pkg = shift;
    return $pkg->{iobs};
}
sub Baseid($){
    my $pkg = shift;
    return $pkg->{baseid};
}
sub Rfrq($$){
  my ($pkg,$ich) = @_;
  my $frq_tab = $pkg->{frq_tab};
  my $line = $$frq_tab[$ich-1];
  my @terms = split(/\s+/,$line);
  return $terms[0];
}

sub Prc_epoch($){
    my $pkg = shift;
    return $pkg->{prc_epoch};
}

sub Obs_start($){
  my $pkg = shift;
  return $pkg->{obs_start};
}
sub Obs_stop($){
  my $pkg = shift;
  return $pkg->{obs_stop};
}
sub Obs_prt($){
  my $pkg = shift;
  return $pkg->{obs_prt};
}

sub Read($$){
    my ($pkg,$fname) = @_;
    $pkg->{fname} = $fname;
    unless(open(IN,$fname)){
	print STDERR "Error in K5_corfmt: Open faild to read $fname \n";
	return -1;
    }
    my $stp = 0;
    my @frq_tab;
    while(<IN>){
	chomp;
	next if(/^\#/);
	if($stp  == 0){ # hostname
	    $pkg->{prc_host} = $_;   $stp++; 
	}elsif($stp == 1){ # KSP fname
	    $pkg->{ksp_fname} = $_;   $stp++; 
	}elsif($stp == 2){ # OBS Number
	    $pkg->{iobs} = $_;   $stp++; 
	}elsif($stp == 3){ # Baseid 
	    $pkg->{baseid} = $_;   $stp++; 
	}elsif($stp == 4){ # process time
	    my @ydhms = split(/\s+/);
	    my $tm = new Time_lib;
	    $tm->Set_time_ydhms(@ydhms);
	    $pkg->{prc_epoch} = $tm;   $stp++; 
	}elsif($stp == 5){ # Xstname
	    $pkg->{Xst_name} = $_;   $stp++; 
	}elsif($stp == 6){ # Xst XYZ
	    my @xyz = split(/\s+/);
	    $pkg->{Xst_xyz} = \@xyz;   $stp++; 
	}elsif($stp == 7){ # Xst data fname
	    $pkg->{Xst_dfname} = $_;   $stp++; 
	}elsif($stp == 8){ # Ystname
	    $pkg->{Yst_name} = $_;   $stp++; 
	}elsif($stp == 9){ # Tst XYZ
	    my @xyz = split(/\s+/);
	    $pkg->{Yst_xyz} = \@xyz;   $stp++; 
	}elsif($stp == 10){ # Yst data fname
	    $pkg->{Yst_dfname} = $_;   $stp++; 
	}elsif($stp == 11){ # srcname
	    $pkg->{srcname} = $_;   $stp++; 
	}elsif($stp == 12){ # src ra
	    $pkg->{src_ra} = $_;   $stp++; 
	}elsif($stp == 13){ # src dec
	    $pkg->{src_dec} = $_;   $stp++; 
	}elsif($stp == 14){ # src epoch
	    $pkg->{src_epoch} = $_;   $stp++; 
	}elsif($stp == 15){ # src GMST
	    $pkg->{src_gmst} = $_;   $stp++; 
	}elsif($stp == 16){ # start
	    my @ydhms = split(/\s+/);
	    my $tm = new Time_lib;
	    $tm->Set_time_ydhms(@ydhms);
	    $pkg->{obs_start} = $tm;   $stp++; 
	}elsif($stp == 17){ # stop
	    my @ydhms = split(/\s+/);
	    my $tm = new Time_lib;
	    $pkg->{obs_stop} = $tm;   $stp++; 
	}elsif($stp == 18){ # prt 
	    my @ydhms = split(/\s+/);
	    my $tm = new Time_lib;
	    $pkg->{obs_prt} = $tm;   $stp++; 
	}elsif($stp == 19 ){ # tau0 
	    $pkg->{tau0} = $_;   $stp++; 
	}elsif($stp == 20 ){ # tau1
	    $pkg->{tau1} = $_;   $stp++; 
	}elsif($stp == 21 ){ # tau2 
	    $pkg->{tau2} = $_;   $stp++; 
	}elsif($stp == 22 ){ # tau3
	    $pkg->{tau3} = $_;   $stp++; 
	}elsif($stp == 23 ){ # clock offset
	    my @clock = split(/\s+/);
	    $pkg->{clock_offset} = \@clock;   $stp++; 
	}elsif($stp == 24 ){ # clock rate
	    $pkg->{clock_rate} = $_;   $stp++; 
	}elsif($stp == 25 ){ # eop
	    my @eop = split(/\s+/);
	    $pkg->{eop} = \@eop;   $stp++; 
	}elsif($stp == 26 ){ # nch
	    $pkg->{nch} = $_;   $stp++; 
	}elsif($stp >= 27 && $stp < 28+$pkg->{nch} ){ # freq
	    push(@frq_tab, ($_)); 	    $stp++;
	    if( $stp < 27 + $pkg->{nch}){ next;}
	    else{ $pkg->{frq_tab} = \@frq_tab;  }
	}elsif($stp == 28 + $pkg->{nch} ){ # Sampling freq 
	    $pkg->{fsamplfing} = $_;   $stp++; 
	}elsif($stp == 29 + $pkg->{nch} ){ # bit 
	    $pkg->{bit} = $_;   $stp++; 
	}elsif($stp == 30 + $pkg->{nch} ){ # pp time (sec)
	    $pkg->{pp_sec} = $_;   $stp++; 
	}elsif($stp == 31 + $pkg->{nch} ){ # lag size
	    $pkg->{lag} = $_;   $stp++; 
	}elsif($stp == 32 + $pkg->{nch} ){ # npp
	    $pkg->{npp} = $_;   $stp++; 
	}else{last;}	
    }

    close(IN);
}



1;
