# @Version: $Id: Llh.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Llh;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(llh_cnv);

BEGIN{
    $R_EARTH =  6378137.0;
    $FLTNING = 1.0/298.257222101;
    $PI =  atan2(1.,1.)*4.0;
    $ECC = sqrt($FLTNING*(2.0-$FLTNING));
    $ECC2 = $ECC * $ECC;
    $RAD2DEG = 180./$PI;
}


sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub llh_cnv(@){
    my ($this, @xyz) = @_;

    my $lon= atan2($xyz[1],$xyz[0]) ;
    my $x2y2 = sqrt($xyz[0]* $xyz[0] + $xyz[1] * $xyz[1]);
    my $b1;
    my $b0 = $b1 = atan2($xyz[2], $x2y2);
    my $n1;
    my $n0 = $n1 = $R_EARTH / sqrt(1.0 - $ECC2 * sin($b0)*sin($b0));
    do{
	$b0 = $b1;  
	$n0 = $n1;
  	$b1 = atan2($xyz[2]+ $n0 * $ECC2 * sin($b0), $x2y2);	
	$n1 = $R_EARTH / sqrt(1.0 - $ECC2 * sin($b1) * sin($b1));
    }while( abs($b1 - $b0)/$b1 > 1.0e-7 );
    my $higt = $x2y2 / cos($b1) - $n1; 
    my $lat = $b1;
    
    $lon *= $RAD2DEG;
    $lat *= $RAD2DEG;

    ($lon, $lat, $higt);

#    $ld = int($lon); 
#    $lon = ($lon - $ld) * 60.0;
#    my $lm = int($lon); 
#    my $ls = ($lon - $lm )* 60.0;
#    my $bd = int($lat); 
#    $lat = ($lat - $bd) *60.0;
#    my $bm = int($lat); 
#    my $bs = ($lat - $bm) *60.0;
#    printf("lon: %2d:%2d:%lf  ", (int)ld, (int)lm, ls);
#    printf("lat: %2d:%2d:%lf  ", (int)bd, (int)bm, bs);
#    printf("Hight: %lf \n", higt);

}
