## Read Multi coliumn data 
##  by M.S.  2012/2/28
##    <X>  <Y> .... 
###
# @Version: $Id: Mcol_dat.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Mcol_dat;
use Exporter;
use Carp;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}
sub Colarr($){
    my $pkg = shift;
    return @{$pkg->{cols}};
}

sub Col($$){
    my $pkg = shift;
    my $icol = shift;
    my $ncol = $pkg->{ncol};
    if($icol >= $ncol){
	print STDERR "E Mcol_dat::Colarr(): column($icol) > ncol($ncol)\n";
	return -1;
    }
    my @cols = @{$pkg->{cols}};
    return @{$cols[$icol]};
}

sub Comment($){
    my $pkg = shift;
    @{$pkg->{comment}};
}


sub Read($$){
    my ($pkg,$fname) = @_;
    unless(open(IN,$fname) ){
	print STDERR "Error: Failed to open file($fname) \n";
	return -1;
    }
    my (@cmt, %coldat) = ((),());
    my $flag=0;
    my $line;
    my @terms;
    my $ncol;
    my $icmt=0;
    while($flag==0){
	$line = <IN>;
	if($line=~/^\#/){chomp($line); $cmt[$icmt++] = $line; next;}
	@terms = split(/\s+/,$line);
	$ncol = @terms;
	$flag=1;
    }
    if($ncol > 19){
	print STDERR "E: Too many($ncol) colums: $_";
	print STDERR " Sorry, currently no more than 19 columns are supported.\n";
	usage();
    }
    my (@col1, @col2, @col3, @col4, @col5, @col6,@col7, @col8, @col9,@col10, @col11,
	@col12, @col13, @col14, @col15, @col16,@col17, @col18, @col19);
    my @cols = (\@col1, \@col2, \@col3, \@col4, \@col5, \@col6,\@col7, \@col8, \@col9,
		\@col10, \@col11, \@col12, \@col13, \@col14, \@col15, \@col16, \@col17,
		\@col18, \@col19);
    my $cnt=0;
    $icol=0;
    while(@terms){$cols[$icol++][$cnt] = shift(@terms);    }
    $cnt++;
    while(<IN>){
	if(/^\#/){chomp; $cmt[$icmt++] = $_; next;}
	/\s*/;
	@terms = split(/\s+/,$'); #');
	if(@terms < 2){
	    print STDERR "E: Too few data: $_";
	    next;
	}
	$icol=0;
	while(@terms){
	    $cols[$icol++][$cnt] = shift(@terms);
	}
	$cnt++;
    }
    $pkg->{cols}=\@cols;
    $pkg->{ncol}=$ncol;
    $pkg->{comment}=\@cmt;
    return ($cnt, $ncol);
}

1;
