# @Version: $Id: Sched_db.pm 13 2013-07-06 09:45:06Z sekido $
#
package Sched_db;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(Read Expr Src_name Src_alias Src_alp Src_del Src_epoch Stn_ids Stn_name Stn_xyz Nskd Skd_src Skd_start Skd_stop Skd_stns Stn_diam Src_alp2 Src_del2 Skd_dur);

#require "$ENV{HOME}/prog/perl/UTIL/time.pl";
use lib "$ENV{HOME}/prog/perl/module";
use Time_lib;

BEGIN{

}


sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Expr($){my $this = shift;  $this->{expname};}

sub Stn_ids($){
    my $this = shift;
    my $stndb = $this->{stndb};
    my $idarr = $stndb->{idarr};
    @$idarr;
}

sub Stn_id2($$){
    my $this = shift;
    my $id = shift;
    my $stndb = $this->{stndb};
    my $id2 = $stndb->{id2};
    $id2->{$id};
}

sub Stn_name($$){
    my ($this, $id) = @_;
    my $stndb = $this->{stndb};
    my $stname = $stndb->{station};
    $stname->{$id};
}

sub Stn_xyz($$){
    my ($this, $id) = @_;
    my $stndb = $this->{stndb};
    my $id2 = $this->{id2};
    my $x = $stndb->{x};
    my $y = $stndb->{y};
    my $z = $stndb->{z};
#    ($x->{$id}, $y->{$id}, $z->{$id});
    ($x->{$id2{$id}}, $y->{$id2{$id}}, $z->{$id2{$id}});
}

sub Stn_diam($$){
    my ($this, $id) = @_;
    my $stndb = $this->{stndb};
    my $diam = $stndb->{diam};
    $$diam{$id};

}

sub Nskd($){
    my $this = shift;
    my $skddb = $this->{skddb};
    my $srcname = $skddb->{source};
    return ($#$srcname +1);
}

sub Nch($){
    my $this = shift;
    my $codedb = $this->{codedb};
    my $freq = $codedb->{freq};
    return @{$freq};
}

sub Skd_src($$){
    my ($this, $i) = @_;
    my $skddb = $this->{skddb};
    my $srcname = $skddb->{source};
    if($i<@$srcname){ $$srcname[$i];}
    else{
	print STDERR "Error:  skd_src ($i)  is out of range\n";
    }
}

## mode =0 return yy soy
## mode =1 return yy doy sod
## mode =2 retrun yy doy hh mm ss
## mode =3 return Time_lib;
sub Skd_start($$;$){
    my ($this, $i,$mode) = @_;
    my $skddb = $this->{skddb};
    my $start = $skddb->{start};
    if($i< @$start){ 
	my ($year, $dd, $hh, $mm, $ss) = &Time_sep($$start[$i]);
# 	$$start[$i] =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	my $yy= $1;
# 	my $dd = $2;
# 	my $hh = $3;
# 	my $mm = $4;
# 	my $ss = $5;
# 	my $year = $yy;
# 	if( $year < 1900){ $year += $year> 50 ? 1900 : 2000; }
	
	my $t1 = new Time_lib;
	$t1->Set_time_ydhms($year,$dd,$hh,$mm,$ss);
	my $sod = $t1->Sod();
#	my $sod = (($hh * 60.)+$mm)*60. + $ss;

	if(defined($mode)){
	    if($mode == 0){ 
		my $soy = $dd * 86400. + $sod;
		return ($year, $t1->Soy());
	    }elsif($mode == 1){
		return ($year, $dd, $t1->Sod());
	    }elsif($mode == 2){
		return ($year, $dd, $hh, $mm, $ss);
	    }elsif($mode == 3){
		my $tm = new Time_lib;
		$tm->Set_time_ydhms($year,$dd, $hh,$mm,$ss);
		return $tm;
	    }
	}else{
	    return $t1->Str_fmt1(1);
#	    my $stime = sprintf("%04d/%03d-%02d:%02d:%02d",$year, $dd, $hh, $mm, $ss);
	}
    }else{
	print STDERR "Error:  skd_start ($i)  is out of range\n";
    }
}

sub Skd_start2($$){
    my ($this, $i) = @_;
    my $skddb = $this->{skddb};
    my $start = $skddb->{start};
    my $t1 = new Time_lib;
    if( $i < @$start){ 
	my ($year, $dd, $hh, $mm, $ss) = &Time_sep($$start[$i]);
# 	$$start[$i] =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	my $yy= $1;
# 	my $dd = $2;
# 	my $hh = $3;
# 	my $mm = $4;
# 	my $ss = $5;
# 	my $year = $yy > 50 ? $yy + 1900 : $yy + 2000; 
	$t1->Set_time_ydhms($year, $dd, $hh, $mm, $ss);
	$t1->Str_fmt3();
    }else{
	print STDERR "Error:  skd_start ($i)  is out of range\n";
    }
}

sub Skd_dur($$){
    my ($this, $i) = @_;
    my $skddb = $this->{skddb};
    $dur = $skddb->{dur};

    if($i<@$dur){ 
	return $$dur[$i];
    }else{
	print STDERR "Error:  skd_dur ($i)  is out of range\n";
	return -1;
    }
}

## Station based duration (subnet)
sub Skd_dur2($$$){
    my ($this, $i,$id) = @_;
    my $skddb = $this->{skddb};
    $dur1 = $skddb->{dur};
    $dur2 = $skddb->{dur2};
    my $dur = $$dur2[$i];
    $stids = $this->Skd_stns($i);
    my $indx = index($stids,$id);
    if($indx < 0){
	print STDERR "Warning Skd_dur2(): failed find ID:$id from IDs($stids) of scan($i)\n";
	return -1;
    }

    unless(defined(@$dur)){
	return -1;
    }

    if($indx< @$dur){ 
	return $$dur[$indx];
    }elsif($#{$dur} == -1){
	return $$dur1[$i];
    }else{
	print STDERR "Error in Skd_dur2(): order($indx) of StID:$id is out of # of dur. arrays at scan($d).\n";
	return -1;
    }
}

## mode =0 return yy soy
## mode =1 return yy doy sod
## mode =2 retrun yy doy hh mm ss
## mode =3 return Time_lib
sub Skd_stop($$;$){
    my ($this, $i,$mode) = @_;
    my $skddb = $this->{skddb};
    my $start = $skddb->{start};
    my $dur = $skddb->{dur};
    if($i<@$start){ 
#	my $st1 = $this->{year} . $$start[$i];
	my ($year, $dd, $hh, $mm, $ss) = &Time_sep($$start[$i]);
# 	$$start[$i] =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	my $yy= $1;
# 	my $dd = $2;
# 	my $hh = $3;
# 	my $mm = $4;
# 	my $ss = $5;
# 	my $year = $yy;
# 	$year += $year> 50 ? 1900 : 2000; 

	my  $tm = new Time_lib;
	$tm->Set_time_ydhms($year,$dd, $hh,$mm,$ss);
	my $tme = $tm + $$dur[$i];
#	my $entime = add_time($$start[$i], $$dur[$i]);
# 	$entime =~/(\d{4})(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	my $yy= $1;
# 	my $dd = $2;
# 	my $hh = $3;
# 	my $mm = $4;
# 	my $ss = $5;
# 	my $year = $yy;
# 	if( $year < 1900){ $year += $year> 50 ? 1900 : 2000; }
# 	my $sod = (($hh * 60.)+$mm)*60. + $ss;
	my $sod = $tme->Sod();
	my $soy = $tme->Soy();

	if(defined($mode)){
	    if($mode ==0){
#	    	my $soy = $dd * 86400. + $sod;
		return ($tme->Year(), $tme->Soy());
	    }elsif($mode == 1){
		return ($tme->Year(), $tme->Doy(), $tme->Sod());
	    }elsif($mode == 2){
#		return ($year, $dd, $hh, $mm, $ss);
		return $tme->YDHms();
	    }elsif($mode == 3){
#		my $tm = new Time_lib;
#		$tm->Set_time_ydhms($yy,$dd, $hh,$mm,$ss);
		return $tme;
	    }
	}else{
#	    sprintf("%04d/%03d-%02d:%02d:%02d", $1, $2, $3, $4, $5);
	    $tme->Str_fmt1(1);
	}
    }else{
	print STDERR "Error:  skd_start ($i)  is out of range\n";
    }
}

## mode =0 return yy soy
## mode =1 return yy doy sod
## mode =2 retrun yy doy hh mm ss
## mode =3 return Time_lib
## Using Duration time for Subnet 
sub Skd_stop2($$$;$){ # station base(subnet)
    my ($this, $i,$id,$mode) = @_;
    my $skddb = $this->{skddb};
    my $start = $skddb->{start};
    my $dur1 = $skddb->{dur};
    my $dur2 = $skddb->{dur2};
    my $dur = $$dur2[$i];
    my $stids = $this->Skd_stns($i);
    my $indx = index($stids, $id);
    my $flag_subnet = 1;
    if( $#{$dur} == -1){
	$dur = $dur1;
	$flag_subnet = 0;
    }
    

    if($indx < 0){
	print STDERR "Warning Skd_dur2(): failed find ID:$id from IDs($stids) of scan($i)\n";
	return -1;
    }

    if($i<@$start){ 
#	my $st1 = $this->{year} . $$start[$i];
	my ($year, $dd, $hh, $mm, $ss) = &Time_sep($$start[$i]);

# 	$$start[$i] =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	my $yy= $1;
# 	my $dd = $2;
# 	my $hh = $3;
# 	my $mm = $4;
# 	my $ss = $5;
# 	my $year = $yy;
# 	$year += $year> 50 ? 1900 : 2000; 
	my  $tm = new Time_lib;
	$tm->Set_time_ydhms($year,$dd, $hh,$mm,$ss);
	my $tme;
	if($flag_subnet == 1){
	    $tme = $tm +  $$dur[$indx];
	}else{
	    $tme = $tm +  $$dur[$i];
	}

	my $sod = $tme->Sod();
	my $soy = $tme->Soy();

	if(defined($mode)){
	    if($mode ==0){
#	    	my $soy = $dd * 86400. + $sod;
		return ($tme->Year(), $tme->Soy());
	    }elsif($mode == 1){
		return ($tme->Year(), $tme->Doy(), $tme->Sod());
	    }elsif($mode == 2){
#		return ($year, $dd, $hh, $mm, $ss);
		return $tme->YDHms();
	    }elsif($mode == 3){
#		my $tm = new Time_lib;
#		$tm->Set_time_ydhms($yy,$dd, $hh,$mm,$ss);
		return $tme;
	    }
	}else{
#	    sprintf("%04d/%03d-%02d:%02d:%02d", $1, $2, $3, $4, $5);
	    $tme->Str_fmt1(1);
	}
    }else{
	print STDERR "Error:  skd_start ($i)  is out of range\n";
    }
}

sub Skd_stns($$){
 my ($this, $i) = @_;
 my $skddb = $this->{skddb};
 my $stnid = $skddb->{stations};
 if($i<@$stnid){ 
     my @terms = split(//,$$stnid[$i]);
     my $ids = $terms[0];
     my $i;
     for($i=2; $i<@terms; $i+=2){
	 $ids = $ids . $terms[$i];
     }
     $ids;
 }else{
     print STDERR "Error:  skd_stns ($i)  is out of range\n";
     return "";
 }
}


sub Nsrc($){ my $this = shift; $this->{nsrc};}
sub Src_name($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $srcname = $srcdb->{srcname};
    if($i< @$srcname){ $$srcname[$i];}
    else{ print STDERR "Error: srcname ($i)  is out of range\n";  }
}
sub Src_alias($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $alias = $srcdb->{alias};
    if($i< @$alias){ $$alias[$i];}
    else{ print STDERR "Error: alias ($i)  is out of range\n";  }
}


sub Src_alp($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $alp = $srcdb->{alp};
    if($i< @$alp){ 
	my @terms = split(/\s+/, $$alp[$i]);
	my $alpha 
	    = sprintf("%+3d:%02d:%7.3f",
		      $terms[0], $terms[1], $terms[2]);
    }
    else{ print STDERR "Error: src_alp ($i) is out of range\n";  }
}

sub Src_alp2($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $alp = $srcdb->{alp};
    if($i< @$alp){ 
	my @terms = split(/\s+/, $$alp[$i]);
	my $alpha 
	    = sprintf("%+3dh %02dm %7.3fs",
		      $terms[0], $terms[1], $terms[2]);
    }
    else{ print STDERR "Error: src_alp ($i) is out of range\n";  }
}

sub Src_del($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $del = $srcdb->{del};
    if($i< @$del){ 
	my @terms = split(/\s+/, $$del[$i]);
	my $delta 
	    = sprintf("%+3d:%02d:%7.3f",
		      $terms[0], $terms[1], $terms[2]);
    }
    else{ print STDERR "Error: src_del ($i) is out of range\n";  }
}

sub Src_del2($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $del = $srcdb->{del};
    if($i< @$del){ 
	my @terms = split(/\s+/, $$del[$i]);
	my $sint = int($terms[2]);
	my $sfrac = ($terms[2] - $sint)*1.e3;
	my $delta 
	    = sprintf("%+3d%02d'%02d\".%3.0f",
		      $terms[0], $terms[1], $sint, $sfrac);
    }
    else{ print STDERR "Error: src_del ($i) is out of range\n";  }
}

sub Src_epoch($$){
    my ($this, $i) = @_;
    my $srcdb = $this->{srcdb};
    my $cord = $srcdb->{coord};
    if($i< @$cord){ $$cord[$i];  }
    else{ print STDERR "Error: src_epoch ($i) is out of range\n";  }
}

sub Srate($){
  my $pkg = shift;
  my $code = $pkg->{codedb};   
  return $code->{srate};
}

sub Read($$){
    my ($this, $infile) =@_;

    open(IN, $infile) || die "Cannot open file $infile \n";

#    my (%stndb, %srcdb, %skddb);

    my $buf  = <IN>;
    my @terms = split(/[\s]+/,$buf);
    while($terms[0] eq '\\$EXPER' ){
	if(eof(IN)){
	    print STDERR "There are no Experiment name at \$EXPER entry.\n";
	    exit(1);
	}
	$buf = <IN> ;
	@terms = split(/\s+/,$buf);
    }
    $this->{expname} = $terms[1];
    

#    $this->{year} = $yy;

    seek(IN, 0, 0);
    $buf = <IN>; 
    $buf = <IN> while($buf !~/\$STATION/);
#    $this->{nstn} =  get_stn(IN,\%stndb);
    my $nstn =  $this->get_stn(IN);

    seek(IN,0, 0);
    $buf = <IN>;
    $buf = <IN> while($buf !~/\$SOURCE/);
#    $this->{nsrc} = get_src(IN,\%srcdb);
    my $nsrc = $this->get_src(IN);

    seek(IN,0, 0);
    $buf = <IN> while($buf !~/\$SKED/);
#    $this->{nskd} = get_skd(IN,\%skddb);
    my $nskd = $this->get_skd(IN);

    seek(IN,0, 0);
    $buf = <IN> while($buf !~/\$CODE/);
    $this->get_code(IN);

#    $this->{stndb} = \%stndb;
#    $this->{srcdb} = \%srcdb;
#    $this->{skddb} = \%skddb;
    
    close(IN);
}

sub get_stn ($$)
{
    my ($pkg,$in) = @_;
    my $p = caller;
    my $I = $p. "::" . $in;
    my %stndb;
    my (%id, @idarr,%id2, %x, %y, %z, %stat, %diam);
    my $cnt =0;
    my $cnts =0;
    while( <$I>){
	next if(/^\*/);
#	if(/^A\s+(\S+)\s+(\S+)/){
	if(/^A/){
	    my @terms = split(/\s+/);
	    $id{$terms[2]} = $terms[1];
	    $idarr[$cnts++] = $terms[1];
	    $stat{$terms[1]} = $terms[2];
	    $diam{$terms[1]} = $terms[13];
	    $id2{$terms[1]} = $terms[14];
	}elsif(/^P\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/){
#	    if( !defined($id2{$1})){
	    if( grep(/$1/,values(%id2)) ==0){
		print "Station name mismatched $2 [$1] is not in A-list of sked\n";
#		exit(1);
		next;
	    }
	    my $station = $2;
	    my $tmpid2 = $1;
#	    $id2{$station} = $1;
# 	    $x{$id{$station}} = $3;
# 	    $y{$id{$station}} = $4;
# 	    $z{$id{$station}} = $5;
	    $x{$tmpid2} = $3;
	    $y{$tmpid2} = $4;
	    $z{$tmpid2} = $5;
	    $cnt++;
	}else{
	    last;
	}
    }
    
    $stndb{station} = \%stat;
    $stndb{idarr} = \@idarr;
    $stndb{id2} = \%id2;
    $stndb{diam} = \%diam;
    $stndb{'x'} = \%x;
    $stndb{'y'} = \%y;
    $stndb{'z'} = \%z;
    $stndb{nextline} = $_;
    $pkg->{stndb} = \%stndb;
    $pkg->{nstn} = $cnt;
    $cnt;
}


sub get_src ($$)
{
    my ($pkg,$in) = @_;
    my $p = caller;
    my $I = $p. "::" . $in;
    my %srcdb;
    my (@srcname, @alias, @alp, @del, @coord);
    my $cnt =0;
    while( <$I>){
	next if(/^\*/);
	last unless(/(\S+)\s+(\S+)\s+(\d+\s+\d+\s+\S+)\s+([-+]*\s*\d+\s+\d+\s+\S+)\s+(\S+)/);
	
	$srcname[$cnt] = $1;
	$alias[$cnt] = $2;
	$alp[$cnt] = $3;
	$del[$cnt] = $4;
	$coord[$cnt] = $5;
	$cnt++;
    }

    $srcdb{srcname} = \@srcname;
    $srcdb{alias} = \@alias;
    $srcdb{alp} = \@alp;
    $srcdb{del} = \@del;
    $srcdb{coord} = \@coord;
    $srcdb{nextline} = $_;
    $pkg->{srcdb} = \%srcdb;
    $pkg->{nsrc} = $cnt;
    return  $cnt;
}

sub get_skd ($$)
{
    my ($pkg,$in) = @_;
    my $p = caller;
    my $I = $p. "::" . $in;
    my $skddb;
    my (@srcname, @alias, @alp, @del, @coord, @preob, $fcode, @etc, @dur2, @scanid);
    my @ydhms;
    my $cnt =0;
    while(<$I>){
	next if(/^\*/);
	last unless(/(\S+)\s+(\d+)\s+(\S+)\s+PREOB\s+([\d,.]+)\s+(\d+)\s+MIDOB\s+\d+\s+POSTOB\s+(\S+)\s+(.+)/);

	$srcarr[$cnt] = $1;
	$preob[$cnt] =$2;
	$fcode = $3;
	$start[$cnt] = $4;
	$dur[$cnt] = $5;
	$stns[$cnt] = $6;
	$etc[$cnt] = $7;
	if(length($start[$cnt]) < 11){
	    print STDERR "E Sched_db::get_skd(): Failed to get timecode.\n";
	    print STDERR "  Time format is wrong: $_ \n";
	    next;
	}
	my $nstn = length($stns[$cnt])/2;
	my @itm = split(/\s+/,$etc[$cnt]);
	for(my $i=0; $i<$nstn+1; $i++){ shift(@itm);}
	$dur2[$cnt] = \@itm;
	my @ydhms = &Time_sep($start[$cnt]);

# 	$start[$cnt] =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
# 	@ydhms = ($1, $2, $3, $4, $5); 
	$scanid[$cnt] = sprintf("%03d-%02d%02d", $ydhms[1],$ydhms[2],$ydhms[3]);
	if($cnt >0){
	    my @ydhms2 = &Time_sep($start[$cnt-1]);
	    if(&arr_cmp(\@ydhms,\@ydhms2)){ # Equal 
		$scanid[$cnt-1] = sprintf("%03d-%02d%02da", $ydhms[1],$ydhms[2],$ydhms[3]);
		$scanid[$cnt] = sprintf("%03d-%02d%02db", $ydhms[1],$ydhms[2],$ydhms[3]);
	    }
	}
	$cnt ++;
    }
    $tmp=$_;

    $skddb{source} = \@srcarr;
    $skddb{start} = \@start;
    $skddb{dur} = \@dur;
    $skddb{dur2} = \@dur2;
    $skddb{stations} = \@stns;
    $skddb{preob} = \@preob;
    $skddb{fcode} = $fcode;
    $skddb{etc} = \@etc;
    $skddb{nextline} = $_;
    $pkg->{skddb} = \%skddb;
    $pkg->{nskd} = $cnt;
    return $cnt;
}


sub get_code ($$)
{
    my ($pkg,$in) = @_;
    my $p = caller;
    my $I = $p. "::" . $in;
    my %codedb;
    my (@freq,@pfalf,@bw ,@band );
    while( <$I>){
	next if(/^\*/);
#	if(/^A\s+(\S+)\s+(\S+)/){
	if(/^F/){ # CODE
	    my @terms = split(/\s+/);
	    shift(@terms);
	    $codedb{code} = shift(@terms);
	    $codedb{code2} = shift(@terms);
	    $codedb{stations} = \@terms;
	}elsif(/^C\s+(\S.*)/){
	    my $rsd = $1;
	    my @terms = split(/\s+/,$rsd);
	    if(@terms < 6){
		print STDERR "Error in get_code(): C line missing terms\n";
		print STDERR "\tline= $red \n";
		next;
	    }
	    my $ich = $terms[4] -1;
	    $freq[$ich] = $terms[2];
	    $pcalf[$ich] = $terms[3];
	    $bw[$ich] =  $terms[6];
	    $band[$ich] =  $terms[1];
	}elsif(/^R\s+(\S+)\s+(\S+)/){
	    $codedb{srate} = $2;
	}else{
	    last;
	}
    }
    
    $codedb{freq} = \@freq;
    $codedb{pcalf} = \@pcalf;
    $codedb{bw} = \@bw;
    $codedb{band} = \@band;
    $pkg->{codedb} = \%codedb;
}

sub Time_sep($){
    my $tmp = shift;
    $tmp =~/(\d\d)(\d{3})(\d\d)(\d\d)(\d\d)/;
    my @ydhms = ($1, $2, $3, $4, $5); 
    $ydhms[0]  += $ydhms[0] < 50 ? 2000: 1900 ;
    return @ydhms;
    
}

sub arr_cmp(\@\@){
    my $arr1 = shift;
    my $arr2 = shift;

    my $ret =0;
    return $ret unless($#$arr1 == $#$arr2);
    
    for(my $i=0; $i < @$arr1; $i++){
#	print "arr1 =$$arr1[$i]  arr2=$$arr2[$i]\n";
	if($$arr1[$i] eq $$arr2[$i]){
	    $ret =1;
	}else{
	    $ret =0; last;
	}
    }

    return $ret;
}
