# @Version: $Id: Sdelay_dat.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Sdelay_dat;
use Exporter;
@ISA = qw(Exporter);
use Time_lib;

@EXPORT = qw(Read_sdelarr Ret_result Ret_nobs Ret_tau Ret_sdeldat);

BEGIN{
    ;
}

sub new ($){
    my $pkg = shift;
    my @aaa;
    my $this = {'sdel_arr' => \@aaa};
    bless $this;
    $this;
}



sub Ret_nobs($){
    my $this = shift;
    my $dbarr = $this->{sdel_arr};
    my $nobs = @$dbarr;
}

sub Vbw($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    $$dbarr[$iobs]->{VBW}

}

sub Prt($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    $$dbarr[$iobs]->{PRT};
}

sub Srcname($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    $$dbarr[$iobs]->{src_name};
}

sub Ret_result($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$iobs];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
}
sub Ret_delay($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$iobs];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
    my $taus = $sdel_dt->{tau};

    return($$taus[0] + $terms[2]);
}

sub Ret_rate($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$iobs];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
    my $taus = $sdel_dt->{tau};
    return($$taus[1] + $terms[4]);
}

sub Ret_del_err($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$iobs];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
    return($terms[3]);
}

sub Ret_rate_err($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$iobs];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
    return($terms[5]);
}

sub Ret_tau($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$i];

    my $taus = $sdel_dt->{tau};
    
    return (@$taus);
}

sub Ret_sdeldb($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    $$dbarr[$iobs];
}

sub Ret_sdelarr($){
    my $this = shift;
    my $dbarr = $this->{sdel_arr};

}

sub Read_sdelarr($$){
    my ($this, $file) = @_;
    
    open(IN, $file) || die "Error: Cannot open file $file\n";
    
    while(!eof(IN)){
	$this->Read_sdeldat(IN);
    }
    close(IN);
}


sub Read_sdeldat($$){
    my ($this, $in) = @_;
    
    my $p = caller;
    my $I = $p . "::" . $in;
    my $db_arr = $this->{sdel_arr};
    my $line = <$I>;
    while($line !~/\$OBS/ && !eof($I)){
	$line = <$I>;
    }
    if(eof($I)){
	print STDERR "EOF found\n";
	last;
    }
    
    my %sdel_db;
    
    my $flag=0;    
    while($flag==0 && !eof($I)){
	my $line = <$I>;
	my @terms = split(/[\s\t]+/, $line);
	next if (@terms <1);
	if($terms[0] =~/\$BASELINE/){
	    $sdel_db{xstname} = $terms[1];
	    $sdel_db{ystname} = $terms[2];
	}elsif($terms[0] =~/\$PRT/){
	    my $time_dt = new Time_lib;
	    $time_dt->Set_time_ydhms($terms[1], $terms[2], 
				     $terms[3], $terms[4], 
				     $terms[5]);
	    $sdel_db{PRT} = $time_dt;
	}elsif($terms[0] =~/\$SOURCE/){
	    $sdel_db{src_name} = $terms[1];
	}elsif($terms[0] =~/SAMPLING/){
	    $sdel_db{Samplingf} = $terms[1];
	}elsif($terms[0] =~/VIDEO_BW/){
	    $sdel_db{VBW} = $terms[1];
	}elsif($terms[0] =~m!NUMBER!){
	    $sdel_db{NPP} = $terms[3];
	}elsif($terms[0] =~m!SEKIBUN!){
	    $sdel_db{NPP} = $terms[1];
	}elsif($terms[0] =~m!APRIORI!){
	    $line = <$I>;
	    my @sterms = split(/\s+/, $line);
	    $sdel_db{tau} = \@sterms;
	}elsif($terms[0] =~m!CLOCK!){
	    $line = <$I>;
	    my @sterms = split(/\s+/, $line);
	    $sdel_db{clkoffst} = \@sterms;
	}elsif($terms[0] =~m!RESULTS! ){
	    my $cnt = 0;
	    my @reslts;
	    my $nterms = -1;
	    while($nterms !=0){
		$line = <$I>;
		my @sterms = split( /[\s\t]+/, $line);
		last if( @sterms < 1 || $sterms[0] =~/\$OBS/);
		$reslts[$cnt] = $line;
		$nterms = @sterms;
		$cnt++;
	    }

	    $sdel_db{results} = \@reslts;
	    $flag=1;   
	}
    }
    
    push(@$db_arr, (\%sdel_db));
    $this->{sdel_arr} = $db_arr;
}

1;
