# @Version: $Id: SpeAna_dat.pm 9 2013-06-30 03:03:30Z vlbi $
#
package SpeAna_dat;
use Exporter;

@ISA = qw(Exporter);

@EXPORT = qw(Frqarr Amp);

BEGIN{
    
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Vid_band($){
    $this = shift;
    $this->{vid_band};
}


sub Res_band($){
    $this = shift;
    $this->{res_band};
}

sub Logdiv($){
    $this = shift;
    $this->{logdiv};
}
sub T_sqp($){
    $this = shift;
    $this->{t_swp};
}

sub RF_Att($){
    $this = shift;
    $this->{rf_attn};
}

sub RF_cent($){
    $this = shift;
    $this->{f_center};
}

sub RF_span($){
    $this = shift;
    $this->{f_span};
}
sub RF_start($){
    $this = shift;
    $this->{f_start};
}

sub RF_stop($){
    $this = shift;
    $this->{f_stop};
}

sub RF_lvl($){
    $this = shift;
    return $this->{ref_lvl};
}

sub Frqarr($){
    $this = shift;
    $this->{frq};
}

sub Amp($){
    $this = shift;
    return $this->{dbamp};
}

sub Read($$){
    my ($this, $fname) = @_;
    open(IN, $fname) || die "Cannot open file $fname\n";

    my (@frq, @dbamp);
    my $icnt =0;
    while(<IN>){
	my @terms = split(/\s+/); 

	if($terms[0] =~/FREcent\s*/){
	    $this->{f_center} = $terms[1];
	}elsif($terms[0] =~/FREspan\s*/){
	    $this->{f_span} = $terms[1];
	}elsif($terms[0] =~/FREstrt\s*/){
	    $this->{f_start} = $terms[1];
	}elsif($terms[0] =~/FREstop\s*/){
	    $this->{f_stop} = $terms[1];
	}elsif($terms[0] =~/REFlvl\s*/){
	    $this->{ref_lvl} = $terms[1];
	}elsif($terms[0] =~/RFAttn\s*/){
	    $this->{rf_attn} = $terms[1];
	}elsif($terms[0] =~/RESbnd\s*/){
	    $this->{res_band} = $terms[1];
	}elsif($terms[0] =~/VIDbnd\s*/){
	    $this->{vid_band} = $terms[1];
	}elsif($terms[0] =~/SWPtim\s*/){
	    $this->{t_swp} = $terms[1];
	}elsif($terms[0] =~/LOGdiv\s*/){
	    $this->{logdiv} = $terms[1];
	}else{
	    /\s*/;
	    my @terms = split(/\s+/,$'); #')
	    if(@terms < 2){
		print STDERR 
		    "Error: Number of item in dat line($icnt) is less than 2\n";
		next;
	    }
	    $frq[$icnt] = $terms[0];
	    $dbamp[$icnt] = $terms[1];
	    $icnt++;
	}

    }
    close(IN);
    $this->{frq} = \@frq;
    $this->{dbamp} = \@dbamp;

}

1;
