# @Version: $Id: Spline.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Splinedt;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(Compute Set_xyarr Kansuti_d);

BEGIN{
}

sub new ($$$){
    my ($pkg, $ndat, $kai, $jbibun) = @_;
    my $this = {};
    bless {
	ndat => $ndat,
	kai => $kai,
	jbun => $jbibun
	};
}

sub Set_node($){
    my $this = shift;
    
    my $i;
    my $kai = $this->{kai};
    my @q;
    my $xarr = $this->{xarr};
    my $npt = $this->{ndat};
    
    for( $i=0;$i<$kai; $i++){
	$q[$i] = $$xarr[0];
	$q[$i+$npt] = $$xarr[$npt-1];
    }
    for($i=0; $i<$npt-$kai; $i++){
	$q[$i+$kai] = 
	    0.5*($$xarr[$i]+ $$xarr[$i+$kai]);
    }
    
    $this->{q} = \@q;
}

sub Deboor_cox($$$){
    my ($this, $kai, $t) = @_;
    my ($a1, $a2);

    my $npt =  $this->{ndat};    
    my $icox = $npt;
    
    my ($i, $k, @bv, $kset);
    my $q = $this->{q}; 
    
    for($i=0; $i<$npt; $i++){  $bv[$i] =0.0;}
    if( $t < $$q[0]){
	printf STDERR "Error:You are specifying earlier epoch than the first data.\n";
	printf STDERR " t(%14.7e) < q[0](%14.7e)\n", $t, $$q[0];
	printf STDERR "Check the program or input data.\n ";
	exit(1);
    }
    if($t > $$q[$icox]){ 
	printf STDERR "Error:You are specifying later epoch than the last data.\n";
	printf STDERR " t(%14.7e) > q[%d](%14.7e)\n", $t, $icox, $$q[$icox];
	printf STDERR "Check the program or input data.\n ";
	exit(1);
    }
    
    for($i=0; $i<$icox; $i++){
	if( $$q[$i] <= $t  && $t < $$q[$i+1]){
	    $bv[$i] = 1.0;
	    $kset = $i;
	    last;
	}
    }
    if( ($$q[$icox -1] <= $t )&& 
	($t <= $$q[$icox] + 1.e-5)){
	$bv[$icox-1] = 1.0;
	$kset = $icox-1;
    }

    for($k=1; $k<$kai; $k++){
	for($i=0; $i<$npt; $i++){   
	    $bv[$i + ($k % 2) * $npt ] =0.0;}
	for($i=$kset - $k; $i<=$kset; $i++){
	    $a1 = $a2 = 0.0;
	    if( $$q[$i+1] != $$q[$i+$k+1]){
		$a1 = ($$q[$i+$k+1] -$t) * 
		    $bv[$i+1 + (($k-1) % 2) * $npt] 
			/ ($$q[$i+$k+1] - $$q[$i+1]);
	    }
	    if( $$q[$i] != $$q[$i+$k]){
		$a2 = ($t - $$q[$i]) 
		    * $bv[ $i + (($k-1) % 2) * $npt] 
			/ ($$q[$i+$k] - $$q[$i]);
	    }
	    $bv[$i + ($k % 2)*$npt] = $a1 + $a2;
	}
	
    }

    $this->{kset} = $kset;
    $this->{bv} = \@bv;
    
}

sub Tokui($){
    my $this = shift;
    print STDERR "Error: matrix is singular\n";
    exit(1);
}

# LU Bunkai, 
#    Definition is A(i,j) = A[i][j] in this order **/

sub Lu_bunkai($){
    my $this = shift;
    my ($i, $k, $j);
    my  ($ip, $idxpv, $kp);
    my ($rnrm, $x, $big, $size, $piv, $em); 
    
    my $A = $this->{bl};
    my (@scale, @ips);
    my $npt = $this->{npt};
    
    for($i=0; $i<$npt; $i++){
	$ips[$i] =$i;
	$rnrm = 0.0;
	for($j=0; $j<$npt; $j++){
	    $x = abs($$A[$i*$npt+$j]);
	    $rnrm = $rnrm > $x ? $rnrm : $x;
	}
	if ($rnrm != 0.0){
	    $scale[$i] = 1.0 / $rnrm;
#	    //      printf("scale[%d] = %lf\n", i, scale[i]);
	}else{
	    &Tokui();
	}
    }
    for($k=0; $k<$npt; $k++){
	$big =0.0;
	for($i=$k; $i<$npt; $i++){
	    $ip = $ips[$i];
	    $size = abs($$A[$ip*$npt+$k])*$scale[$ip];
	    if( $size > $big) {
		$big = $size; 
		$idxpv = $i;
	    }
	}
	&Tokui()  if($big == 0.0); 
	if( $idxpv != $k){
	    $j = $ips[$k];
	    $ips[$k] = $ips[$idxpv];
	    $ips[$idxpv] = $j;
	}
	
#	/* Pivot */
	$kp = $ips[$k];
	$piv = $$A[$kp*$npt+$k];
	for($i=$k+1; $i< $npt; $i++){
	    $ip = $ips[$i];
	    $em = - $$A[$ip*$npt+$k] / $piv;
	    $$A[$ip*$npt + $k] = -$em;
	    if( $em != 0.0){
		for($j= $k+1; $j< $npt; $j++){
		    $$A[$ip*$npt+$j] += $em * $$A[$kp*$npt+$j];}
	    }
	}
    }
    $kp = $ips[$npt-1];
    Tokui()  if($$A[$kp*$npt+$npt-1] ==0.0);

  
}

sub Renritsu_kai($){
    my $this = shift;
    
    my  $sum;
    my ($i, $j, $ib);
    
    my $A = $this->{bl};
    my $alp = $this->{alp};
    my $ips = $this->{ips};
    my $yarr = $this->{yarr};

    for($i=0; $i<$npt; $i++){
	$$alp[$i] = 0.0; }
  
    my $ip = $$ips[0];
  
    $$alp[0]= $$yarr[$ip];
  
    for($i=1; $i< $npt; $i++){
	$ip = $$ips[$i];
	$sum =0.0;
	for($j=0; $j<= $i-1; $j++){
	    $sum += $$A[$ip*$npt+$j] * $$alp[$j];
	}
	$$alp[$i] = $$yarr[$ip] - $sum; 
    }
  
    $ip = $$ips[$npt-1];
    $$alp[$npt-1] = $$alp[$npt-1] / $$A[$ip*$npt + $npt-1];
    
    for($ib = 1; $ib<$npt; $ib++){
	$i = $npt -1 -$ib;
	$ip = $$ips[$i];
	$sum=0.0;
	for($j=$i+1; $j<$npt; $j++){
	    $sum += $$A[$ip*$npt+$j] * $$alp[$j];
	}
	$$alp[$i] = ($$alp[$i] - $sum)/ $$A[$ip*$npt + $i];
  }
    
}


sub Bibun_keiisu($){
   my $pkg = shift;

   my ($i, $jb);
   my ($zj, $zjk);
   
   my $ad  = $this->{alpd};
   my $alp  = $this->{alp};
   my $q  = $this->{q};
  
   for($i=0; $i<$npt; $i++){ $$ad[$i] = $$alp[$i];}
   
   return  f($jbun ==0);

   for($jb=0; $jb< $jbun; $jb++){
       for($i=0; $i<$npt; $i++){
	   $$ad[$i+ (($jb+1) % 2)*$npt] = 0.0;}
       for($i=1; $i<$npt; $i++){
	   $zj = $$q[$i];
	   $zjk = $$q[$i + $kai - $jb -1];
	   if( $zj != $zjk){
	       $$ad[$i + (($jb+1) %2)*$npt] = ($kai - $jb -1)* 
		   ($$ad[$i + ($jb %2)*$npt] - $$ad[$i-1 + ($jb%2)*$npt])
		   /($zjk - $zj);
	   }
       }
   }
   
}

sub Set_xyarr($\@\@){
    my ($pkg, $xarr, $yarr) = @_;
    $pkg -> {xarr} = $xarr;
    $pkg -> {yarr} = $yarr;
}


sub Kansuti_d($$){
    my ($pkg, $t) = @_;
    
    my ($j, $y, $ist);
  
    &Deboor_cox($kai-$jbun , $t);
    my $jbun = $this->{jbun};
    my $kset = $this->{kset};
    my $alpd = $this->{alpd};

    $ist = $kset - $kai +1;
    $y=0.;
    for($j=$ist + $jbun; $j<=$kset; $j++){
	$y +=  $$bv[$j +(($kai-1-$jbun) % 2)*$npt] 
	    * $$alpd[$j + ($jbun %2) *$npt];
    }
    return($y);

}

sub Mt_spline($){
    my $this = shift;
    
    my @bl;
#    my $bv = $this->{bv};
#    my $bl = $this->{bl};

    my $y = $this->{y};
    my $npt = $this->{ndat};
    my $xarr = $this->{xarr};

    my $l;
    my $kai = $this->{kai};
    my $k=0;
    for($l=0; $l<$npt; $l++){
	Deboor_cox($kai, $$xarr[$l]);
	my $bv = $this->{bv};
#	my $bl_tmp = $bl + $l*$npt;
#	$bv =  $bv + (($kai-1) % 2) * $npt;
#	memcpy((void *)bl_tmp, (void *)bv, sizeof(double)*npt );

	for($k=0; $k<$npt; $k++){
	    my $i = $l*$npt + $k;
	    my $j =  (($kai-1) % 2) * $npt + $k;
	    $$bl[$i] = $$bv[$j];
	} 
    }
    $this->{bl} = \@bl;
}

sub Keisu($){
    my $this= shift;
    my $i;
    &Lu_bunkai();
    &Renritsu_kai();
}

sub Compute($){
    Set_node();
    Mt_spline();
    Keisu();
    Bibun_keisu();
}
