# @Version: $Id: Stn_db.pm 9 2013-06-30 03:03:30Z vlbi $
#
package Stn_db;
use Exporter;
use Carp;

@ISA = qw(Exporter);

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read_site_vex($$){
    my ($pkg,$in)=@_;
    my $p = caller;
    my $H;
    if(defined($in)){
	if($in !~/^main/){ $H = $p . "::" . $in;}
	else{ $H =  $in;}
    }else{
	print STDERR "Error in Src_db::Read(): in undefined\n";
	return -1;
    }
    
    my $line = <$H>;
    my $flag=0;
    my %stid;
    my @stname;
    my $site_name;
    while($line !~/^\$/){    
	next if($line =~/^\*/);
	if($line =~/^def\s+(\S+);/){
	    $site_name = $1;
	    push(@stname,($site_name));
	    $flag=1;
	    next;
	}
	next if($flag==0);
	my %stn_db;
	my @xyz;
	my @idarr;
	while(!eof($H) && $flag==1){
	    next if($line =~/^\*/);
	    if($line =~/site_name\s*=\s*(\S+);/){
		$stid{$site_name} = $1;
	    }
	    if($line =~/site_position\s*=\s*(\S+)\s*m*:\s*(\S+)\s*m*:\s*(\S+)\s*m*;/){
		my @xyz = ($1, $2, $3);
		$stn_db{xyz} = \@xyz;
	    }
	    if($line=~/site_type\s*=\s*(\S+)\s*;/){
		my $type =$1;
		$stn_db{type} = $type;
	    }
	    if($line=~/site_ID\s*=\s*(\S+)\s*;/){
		my $id = $1;
		$stn_db{id} = $id;
		push (@idarr,($id));
	    }
	}continue{
	    $line  = <$H> unless(eof($H));
	    if($line =~/^enddef;/){
		$flag=0; 
		$pkg->{$site_name} = \%stn_db;
		last;
	    }
	} # while inside each station defs
    }continue{
	$line = <$H>  unless(eof($H));
    }   ## loop for each stations 

    $pkg->{stname} = \@stname;
    $pkg->{idarr} = \@idarr;

    return $line;
}

sub Stn_list($){
    my $pkg = shift;
    @{$pkg->{stname}};
}

sub Print_stn($$;$){
    my ($pkg,$stn, $out) = @_;
    $out = STDOUT unless(defined($out));
    
    my $stn_db = $pkg->{$stn};
    unless(defined(%$stn_db)){
	print STDERR "Error: station($stn) is not in the Data\n";
	return -1;
    }
    my $xyz = $stn_db->{xyz};
    printf $out "%-8s %s  %13.4f %13.4f  %13.4f \n",
    $stn, $stn_db->{id}, $$xyz[0], $$xyz[1], $$xyz[2]; 

}

1;
