# @Version: $Id: UDPIP.pm 9 2013-06-30 03:03:30Z vlbi $
#
package UDPIP;

use strict "subs";
use Socket;
use Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(udp_server udp_client);

#
#  Usage udp_server(HANDLE [,PORT = 32001])
#

sub udp_server ($$)
{

    my ($S, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $port = $port || 32001;
    $proto = getprotobyname('udp');
 print "port = $port \n";   
    $port = getservbyname($port, 'udp') unless $port =~ /^\d+/;
 print "port = $port \n";   
    socket($S, PF_INET, SOCK_DGRAM, $proto) || die "socket: $!";
    $ent = sockaddr_in($port, INADDR_ANY);
    bind($S, $ent) || die "bind: $!";
    select($S); $|=1; select(STDOUT);
}

#
# Usage udp_client HANDLE [, HOST [, PORT=32001]]
#

sub udp_client ($;$$) {
    my ($S, $host, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $port = $port || 32001;
    $host = $host || 'localhost';

    $proto = getprotobyname('udp');
print "port = $port \n";    
    $port = getservbyname($port, 'udp') unless $port =~ /^\d+/;
print "host = $host, port = $port \n";    
    socket($S, PF_INET, SOCK_DGRAM, $proto) || die "socket: $!";
    $ent = sockaddr_in($port, inet_aton($host));
    select(S); $|=1; select(STDOUT);
    $ent;
}
    





