## @Version: $Id: Del_utl.pm 10 2013-06-30 03:05:34Z vlbi $
##
package Del_utl;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(Read_gdif2 Read_gdat Tarr Ambg Srcname Del Delerr Rate Raterr SNR Amp Aprtarr Aprdel Aprrat );

use lib "/home/sekido/prog/perl/module";
use Time_lib;

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Aprrat($){
    my $this = shift;
    $this->{aprrate};
}

sub Aprdel($){
    my $this = shift;
    $this->{aprdelay};
}

sub Aprtarr($){
    my $this = shift;
    $this->{apr_tmarr};
}

sub Snr($){
    my $this = shift;
    $this->{snr};
}

sub Amp($){
    my $this = shift;
    $this->{amp};
}

sub Raterr($){
    my $this = shift;
    $this->{raterr};
}

sub Rate($){
    my $this = shift;
    $this->{rat};
}

sub Delerr($){
    my $this = shift;
    $this->{delerr};
}

sub Del($){
    my $this = shift;
    $this->{del};
}

sub Srcname($){
    my $this = shift;
    $this->{srcname};
}

sub Ambg($){
    my $this = shift;
    $this->{ambg};
}

sub Tarr($){
    my $this = shift;
    $this->{tarr};
}

sub Read_apr($$){
  my ($this, $infile) = @_;
    
  open(IN, $infile) || die "Cannot open delay $infile \n";
  
  my (@tmarr, @delay, @rate);
  my $cnt=0;
  while(<IN>){
      next if(/^\#/);
      /\s*(\S.*)/;
      my @terms = split(/\s+/,$1);
      my @yd = split(m!/!,$terms[1]);
      my @hms = split(m!:!,$terms[2]);
      $tmarr[$cnt] = new Time_lib;
      $tmarr[$cnt]->Set_time_ydhms($yd[0], $yd[1], $hms[0], $hms[1], $hms[2]);
      $delay[$cnt] = $terms[8];
      $rate[$cnt] = $terms[9];
      $cnt++;
  }
  close(IN);

  $this->{apr_tmarr} = \@tmarr;
  $this->{aprdelay} = \@delay;
  $this->{aprrate} = \@rate;

  $cnt;
}

# yyyy/ddd hh:mm:ss mjd del src ambg amp derr snr
sub Read_gdif2($$){
    my ($this, $infile) = @_;

    open(IN, $infile) || die "Error: Cannot open file $infile \n";
    my (@tarr, @srcname, @ambg, @amp, @ddel, @delerr, @snr);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/\s+/);
	next if(@terms < 9);
	my @yd = split(m!/!, $terms[0]);
	my @hms = split(m!:!, $terms[1]);
	$tarr[$cnt] = new Time_lib;
	$tarr[$cnt]->Set_time_ydhms(@yd, @hms);
	$ddel[$cnt] = $terms[3];
	$srcname[$cnt] = $terms[4];
	$ambg[$cnt] = $terms[5];
	$amp[$cnt] = $terms[6];
	$delerr[$cnt] = $terms[7];
	$snr[$cnt] = $terms[8];
	$cnt++;
    }
    close(IN);
    $this->{tarr} = \@tarr;
    $this->{del} = \@ddel;
    $this->{delerr} = \@delerr;
    $this->{srcname} = \@srcname;
    $this->{ambg} = \@ambg;
    $this->{amp} = \@amp;
    $this->{snr} = \@snr;
    $cnt;
}

# yyyy/ddd hh:mm:ss src ambg amp del delerr rat raterr snr 
sub Read_gdat($$){
    my ($this, $infile) = @_;
    open(IN, $infile) || die "Error: Cannot open file $infile \n";
    my (@tarr, @srcname, @ambg, @amp, @del, @delerr, @rat, @raterr, @snr);
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	my @terms = split(/\s+/);
	next if(@terms < 10);
	my @yd = split(m!/!, $terms[0]);
	my @hms = split(m!:!, $terms[1]);
	$tarr[$cnt] = new Time_lib;
	$tarr[$cnt]->Set_time_ydhms(@yd, @hms);
	$srcname[$cnt] = $terms[2];
	$ambg[$cnt] = $terms[3];
	$amp[$cnt] = $terms[4];
	$del[$cnt] = $terms[5];
	$delerr[$cnt] = $terms[6];
	$rat[$cnt] = $terms[7];
	$raterr[$cnt] = $terms[8];
	$snr[$cnt] = $terms[9];
	$cnt++;
    }    
    close(IN);
    $this->{tarr} = \@tarr;
    $this->{srcname} = \@srcname;
    $this->{ambg} = \@ambg;
    $this->{amp} = \@amp;
    $this->{del} = \@del;
    $this->{delerr} = \@delerr;
    $this->{rat} = \@rat;
    $this->{raterr} = \@raterr;
    $this->{snr} = \@snr;
    $cnt;
}
