## Metrorogical data reading module.
## This data is taken at 3 locations on the Tower (55m,43m,35m) at NICT Koganei
## Data will be available at http://sensingnet.nict.go.jp/SensingnetTop.html
# @Version: $Id: WxTowerDat.pm 9 2013-06-30 03:03:30Z vlbi $
#
package WxTowerDat;
use Exporter;
use Carp;

use Time_lib;

@ISA = qw(Exporter);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$$){
    my $pkg = shift;
    my $infile = shift;
    
    unless(open(IN,$infile)){
	print STDERR "E Failed to WxTowerDat::Read() \n";
	return -1;
    }
    my (@t,@p,@h, @tarr);

    my $icnt = 0;
    my $tdif = 9*3600;
    while(<IN>){
	next if(/^\#/);
	next unless(/^\d{4}/);
	chomp();
	my @terms = split(/[\s,,]+/);
	my @ymdhms = split(m![:,/,-]+!,$terms[0]);
	if(@ymdhms < 6){
	    print "E Unexpected time data: $terms[0] at line= $icont \n";
	    next;
	}
	$tarr[$icnt] = new Time_lib;
	$tarr[$icnt]->Set_time_ymd(@ymdhms);
	$tarr[$icnt] -= $tdif;
	$t[$icnt] = $terms[8];
	$p[$icnt] = $terms[7];
	$h[$icnt] = $terms[10];
	$icnt++;
    }
    $pkg->{temp}  = \@t;
    $pkg->{pres}  = \@p;
    $pkg->{humid} = \@h;
    $pkg->{time}  = \@tarr;
    close(IN);
    return ($#t +1);
}

sub Temp($){
    my $pkg = shift;
    return @{$pkg->{temp}};
}

sub Pres($){
    my $pkg = shift;
    return @{$pkg->{pres}};
}

sub Humid($){
    my $pkg = shift;
    return @{$pkg->{humid}};
}

sub Tarr($){
    my $pkg = shift;
    return @{$pkg->{time}};
}

1;
